DEFINT A-Z

'$INCLUDE: 'qbswap.bi'

DECLARE FUNCTION DOSSHELL (R$, ExecRet)

'   The following two functions are part of the BCOM45 library; the first one
'   frees memory not currently in use so it doesn't get swapped, and the
'   second gives back all memory to the running program.  CALLS TO THESE
'   MUST BE COMMENTED OUT when running from the QB ENVIRONMENT, but should
'   be UNCOMMENTED to compile a stand-alone.

DECLARE SUB ShellSetup ALIAS "b$ShellSetup" ()
DECLARE SUB SetShell ()
DECLARE SUB FixShell ALIAS "b$ShellRecover" ()


'$DYNAMIC

DIM TEST1(32000) AS INTEGER ' Burn up some space to show it really works
DIM TEST2(32000) AS INTEGER
DIM TEST3(32000) AS INTEGER
DIM TEST4(32000) AS INTEGER

PRINT "Give a command to execute, or
INPUT "hit RETURN to shell normally... ", CmdLine$
SHELL CmdLine$

PRINT "XMS installed: ";
IF XMSInstalled THEN
  PRINT "yes"
ELSE
  PRINT "no"
END IF

PRINT "EMS4 installed: ";
IF EMS4Installed THEN
  PRINT "yes"
ELSE
  PRINT "no"
END IF

PRINT "Give a command to execute, or
INPUT "hit RETURN to shell with QBSWAP... ", CmdLine$
ReturnCode = DOSSHELL(CmdLine$, ExecRet)
PRINT "We're baaaaack..."
SELECT CASE ReturnCode
CASE SWAPOK
  PRINT "Swapped OK and returned"
CASE SWAPNOSHRINK
  PRINT "Could not shrink DOS memory size"
CASE SWAPNOSAVE
  PRINT "Could not save program to XMS/EMS/disk"
  SELECT CASE ExecRet
  CASE SWAPNULPROG
    Message$ = "-> No name of program to execute"
  CASE SWAPNULFILE
    Message$ = "-> No swapfile name"
  END SELECT
  PRINT Message$
  PRINT "Therefore a normal shell was executed."
CASE SWAPNOEXEC
  PRINT "Could not execute program"
  SELECT CASE ExecRet
  CASE BADFUNC
    Message$ = "-> bad DOS function number"
  CASE FILENOTFOUND
    Message$ = "-> couldn't find the command interpreter"
  CASE ACCESSDENIED
    Message$ = "-> couldn't open the command interpreter"
  CASE NOMEMORY
    Message$ = "-> insufficient memory to run shell"
  CASE BADENVIRON
    Message$ = "-> invalid environment segment"
  CASE BADFORMAT
    Message$ = "-> invalid format"
  END SELECT
  PRINT Message$
END SELECT
END
END

FUNCTION DOSSHELL (CmdLine$, ExecRet)
'-----------------------------------------------------------------------
' Issue a Doss Shell with swapping of the current program
' to run program CmdLine$
'-----------------------------------------------------------------------
  Program$ = ENVIRON$("COMSPEC")
  IF CmdLine$ <> "" THEN
    CmdLine$ = "/C " + CmdLine$
  END IF
  Temp$ = ENVIRON$("TEMP")
  IF LEN(Temp$) THEN
    IF INSTR(":\", RIGHT$(Temp$, 1)) = 0 THEN
      Temp$ = Temp$ + "\"
    END IF
  END IF
  SwapFile$ = Temp$ + "TMP.TMP" + CHR$(0)
  CALL SetShell
  ReturnCode = QBSwap(Program$, CmdLine$, ExecRet, ""       )
  CALL FixShell
  IF ReturnCode = SWAPNOSAVE THEN
    SHELL CmdLine$                      ' Normal shell if no swapper available
  END IF
  DOSSHELL = ReturnCode
END FUNCTION

SUB SetShell
  ShellSetup
  ' 1024 bytes are preserved in order to have some space to declare
  ' variables after SetShell has done its work.
  Mem& = SETMEM(+1024)
END SUB
